#ifndef  __DSAPI_H
#define __DSAPI_H

#include <windows.h>
#include <tchar.h>

#define LINE_MAX 	1024            /*  Length of line from text file    */
#define strnull(s) (*(s) == 0)
#define strlast(s) ((s) [_tcslen(s) - 1])

#define DM_SHUTDOWN          8889
#define DM_REPAINT           8890
#define DM_BRINGTOFRONT      8891
#define DM_SAVEDATA			 8892
#define DM_RESTOREDATA		 8893
#define DM_POPUP             9182
#define DM_HIDEPOPUP         9183
#define DM_FIRSTDESKTOPPAINT 9184
#define DM_LSSELECT          9185
#define DM_SETTASKBARONTOP   9186
#define DM_SAVESYSTRAY       9210
#define DM_RESTORESYSTRAY    9211
#define DM_CHECKFORAPPBAR    9212
#define	DM_SENDSYSTRAY		 9213
#define DM_SYSTRAY           9214
#define DM_ADDWINDOW		 9220
#define DM_REMOVEWINDOW		 9221
#define DM_MINMAXWIN		 9222
#define DM_ACTIVEWIN		 9223
#define DM_RCPATH			 9230
#define DM_DSPATH			 9231
#define DM_RECYCLE           9260
#define DM_REGISTERMESSAGE   9263
#define DM_UNREGISTERMESSAGE 9264
#define DM_GETREVID			 9265
#define DM_UNLOADMODULE		 9266
#define DM_RELOADMODULE		 9267
#define DM_CONSOLE			 9270
#define DM_SHADETOGGLE       9300
#define DM_VWMUP             9350
#define DM_VWMDOWN           9351
#define DM_VWMLEFT           9352
#define DM_VWMRIGHT          9353
#define DM_VWMNAV            9354
#define DM_SWITCHTON         9355
#define DM_WINLIST           9400

const long magicDWord = 0x49474541;

static enum msgMode {
	warnok,
	warnyes,
	stopok
} mMode;

typedef struct {
    HWND Handle;
    BOOL Visible;
    RECT Position;
    int Desk;
} winData;

typedef void (*BFUNC)(IN HWND caller, IN LPCTSTR args, ...);

typedef struct {
	TCHAR *name;
	BFUNC func;
} bangDat;

typedef struct {
	int off;
	int len;
} iniDat;

#ifdef	__cplusplus
extern "C" {
#endif

__declspec (dllexport) TCHAR **Tokenize(LPCTSTR string, LPTSTR delims);
__declspec (dllexport) void FreeTokens(TCHAR **token_list);
__declspec (dllexport) LPTSTR ExpandVars(LPCTSTR value);
__declspec (dllexport) LPTSTR RCReadValue(LPCTSTR inifile, LPCTSTR section, LPCSTR keyword, LPLONG ptr);
__declspec (dllexport) int RCReadInt(LPCTSTR inifile, LPCTSTR section, LPCSTR keyword, int def);
__declspec (dllexport) BOOL RCReadBool(LPCTSTR inifile, LPCTSTR section, LPCSTR keyword);
__declspec (dllexport) LPTSTR RCReadString(LPCTSTR inifile, LPCTSTR section, LPCSTR keyword, LPTSTR def);
__declspec (dllexport) COLORREF RCReadColor(LPCTSTR inifile, LPCTSTR section, LPCSTR keyword, COLORREF def);
__declspec (dllexport) BOOL RCWriteValue(LPTSTR inifile, LPTSTR section, LPTSTR keyword, LPCTSTR value);
__declspec (dllexport) int DSMessage(HWND hWnd, int mode, LPCTSTR title, LPCTSTR msg, DWORD code);
__declspec (dllexport) BOOL BangExec(HWND caller, LPCTSTR command, LPCTSTR args);
__declspec (dllexport) BOOL AddBang(LPCTSTR command, void *f);
__declspec (dllexport) BOOL DelBang(LPCTSTR command);
__declspec (dllexport) HWND GetShellWindow();
__declspec (dllexport) LPTSTR GetShellPath();
__declspec (dllexport) LPTSTR GetRCPath();
__declspec (dllexport) HBITMAP GetImage(LPTSTR imgPath);
__declspec (dllexport) void GetImageSize(HBITMAP hBitmap, int *x, int *y);
__declspec (dllexport) void TransDraw(HDC dc, int X, int Y, int wd, int ht, HDC mDC, int sx, int sy, COLORREF cl);
__declspec (dllexport) HRGN LoadRegion(LPTSTR nRegionID, HMODULE hMod);
__declspec (dllexport) HBITMAP IcoToBmp(HICON hIcon);
__declspec (dllexport) HRGN BmpToRgn(HBITMAP hBmp, COLORREF cTrans, COLORREF cTol, int x, int y);
__declspec (dllexport) HICON GetIcon(LPCSTR icon);

#ifdef	__cplusplus
};
#endif

#endif
